---
title: Get a list of entity relations
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Software Catalog
---

# Get a list of entity relations{% #get-a-list-of-entity-relations %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                              |
| ----------------- | --------------------------------------------------------- |
| ap1.datadoghq.com | GET https://api.ap1.datadoghq.com/api/v2/catalog/relation |
| ap2.datadoghq.com | GET https://api.ap2.datadoghq.com/api/v2/catalog/relation |
| app.datadoghq.eu  | GET https://api.datadoghq.eu/api/v2/catalog/relation      |
| app.ddog-gov.com  | GET https://api.ddog-gov.com/api/v2/catalog/relation      |
| us2.ddog-gov.com  | GET https://api.us2.ddog-gov.com/api/v2/catalog/relation  |
| app.datadoghq.com | GET https://api.datadoghq.com/api/v2/catalog/relation     |
| us3.datadoghq.com | GET https://api.us3.datadoghq.com/api/v2/catalog/relation |
| us5.datadoghq.com | GET https://api.us5.datadoghq.com/api/v2/catalog/relation |

### Overview

Get a list of entity relations from Software Catalog.

OAuth apps require the `apm_service_catalog_read` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#software-catalog) to access this endpoint.



### Arguments

#### Query Strings

| Name              | Type    | Description                                                                                                                                                                                                                                                                           |
| ----------------- | ------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| page[offset]      | integer | Specific offset to use as the beginning of the returned page.                                                                                                                                                                                                                         |
| page[limit]       | integer | Maximum number of relations in the response.                                                                                                                                                                                                                                          |
| filter[type]      | enum    | Filter relations by type. Allowed enum values: `RelationTypeOwns, RelationTypeOwnedBy, RelationTypeDependsOn, RelationTypeDependencyOf, RelationTypePartsOf, RelationTypeHasPart, RelationTypeOtherOwns, RelationTypeOtherOwnedBy, RelationTypeImplementedBy, RelationTypeImplements` |
| filter[from_ref]  | string  | Filter relations by the reference of the first entity in the relation.                                                                                                                                                                                                                |
| filter[to_ref]    | string  | Filter relations by the reference of the second entity in the relation.                                                                                                                                                                                                               |
| include           | enum    | Include relationship data. Allowed enum values: `entity, schema`                                                                                                                                                                                                                      |
| includeDiscovered | boolean | If true, includes relationships discovered by APM and USM.                                                                                                                                                                                                                            |

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
List entity relation response.

| Parent field    | Field           | Type      | Description                                                                                                                                                                                                                                                                  |
| --------------- | --------------- | --------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|                 | data            | [object]  | Array of relation responses                                                                                                                                                                                                                                                  |
| data            | attributes      | object    | Relation attributes.                                                                                                                                                                                                                                                         |
| attributes      | from            | object    | Relation entity reference.                                                                                                                                                                                                                                                   |
| from            | kind            | string    | Entity kind.                                                                                                                                                                                                                                                                 |
| from            | name            | string    | Entity name.                                                                                                                                                                                                                                                                 |
| from            | namespace       | string    | Entity namespace.                                                                                                                                                                                                                                                            |
| attributes      | to              | object    | Relation entity reference.                                                                                                                                                                                                                                                   |
| to              | kind            | string    | Entity kind.                                                                                                                                                                                                                                                                 |
| to              | name            | string    | Entity name.                                                                                                                                                                                                                                                                 |
| to              | namespace       | string    | Entity namespace.                                                                                                                                                                                                                                                            |
| attributes      | type            | enum      | Supported relation types. Allowed enum values: `RelationTypeOwns,RelationTypeOwnedBy,RelationTypeDependsOn,RelationTypeDependencyOf,RelationTypePartsOf,RelationTypeHasPart,RelationTypeOtherOwns,RelationTypeOtherOwnedBy,RelationTypeImplementedBy,RelationTypeImplements` |
| data            | id              | string    | Relation ID.                                                                                                                                                                                                                                                                 |
| data            | meta            | object    | Relation metadata.                                                                                                                                                                                                                                                           |
| meta            | createdAt       | date-time | Relation creation time.                                                                                                                                                                                                                                                      |
| meta            | definedBy       | string    | Relation defined by.                                                                                                                                                                                                                                                         |
| meta            | modifiedAt      | date-time | Relation modification time.                                                                                                                                                                                                                                                  |
| meta            | source          | string    | Relation source.                                                                                                                                                                                                                                                             |
| data            | relationships   | object    | Relation relationships.                                                                                                                                                                                                                                                      |
| relationships   | fromEntity      | object    | Relation to entity.                                                                                                                                                                                                                                                          |
| fromEntity      | data            | object    | Relationship entry.                                                                                                                                                                                                                                                          |
| data            | id              | string    | Associated data ID.                                                                                                                                                                                                                                                          |
| data            | type            | string    | Relationship type.                                                                                                                                                                                                                                                           |
| fromEntity      | meta            | object    | Entity metadata.                                                                                                                                                                                                                                                             |
| meta            | createdAt       | string    | The creation time.                                                                                                                                                                                                                                                           |
| meta            | ingestionSource | string    | The ingestion source.                                                                                                                                                                                                                                                        |
| meta            | modifiedAt      | string    | The modification time.                                                                                                                                                                                                                                                       |
| meta            | origin          | string    | The origin.                                                                                                                                                                                                                                                                  |
| relationships   | toEntity        | object    | Relation to entity.                                                                                                                                                                                                                                                          |
| toEntity        | data            | object    | Relationship entry.                                                                                                                                                                                                                                                          |
| data            | id              | string    | Associated data ID.                                                                                                                                                                                                                                                          |
| data            | type            | string    | Relationship type.                                                                                                                                                                                                                                                           |
| toEntity        | meta            | object    | Entity metadata.                                                                                                                                                                                                                                                             |
| meta            | createdAt       | string    | The creation time.                                                                                                                                                                                                                                                           |
| meta            | ingestionSource | string    | The ingestion source.                                                                                                                                                                                                                                                        |
| meta            | modifiedAt      | string    | The modification time.                                                                                                                                                                                                                                                       |
| meta            | origin          | string    | The origin.                                                                                                                                                                                                                                                                  |
| data            | subtype         | string    | Relation subtype.                                                                                                                                                                                                                                                            |
| data            | type            | enum      | Relation type. Allowed enum values: `relation`                                                                                                                                                                                                                               |
|                 | included        | [object]  | List relation response included entities.                                                                                                                                                                                                                                    |
| included        | attributes      | object    | Entity attributes.                                                                                                                                                                                                                                                           |
| attributes      | apiVersion      | string    | The API version.                                                                                                                                                                                                                                                             |
| attributes      | description     | string    | The description.                                                                                                                                                                                                                                                             |
| attributes      | displayName     | string    | The display name.                                                                                                                                                                                                                                                            |
| attributes      | kind            | string    | The kind.                                                                                                                                                                                                                                                                    |
| attributes      | name            | string    | The name.                                                                                                                                                                                                                                                                    |
| attributes      | namespace       | string    | The namespace.                                                                                                                                                                                                                                                               |
| attributes      | owner           | string    | The owner.                                                                                                                                                                                                                                                                   |
| attributes      | tags            | [string]  | The tags.                                                                                                                                                                                                                                                                    |
| included        | id              | string    | Entity ID.                                                                                                                                                                                                                                                                   |
| included        | meta            | object    | Entity metadata.                                                                                                                                                                                                                                                             |
| meta            | createdAt       | string    | The creation time.                                                                                                                                                                                                                                                           |
| meta            | ingestionSource | string    | The ingestion source.                                                                                                                                                                                                                                                        |
| meta            | modifiedAt      | string    | The modification time.                                                                                                                                                                                                                                                       |
| meta            | origin          | string    | The origin.                                                                                                                                                                                                                                                                  |
| included        | relationships   | object    | Entity relationships.                                                                                                                                                                                                                                                        |
| relationships   | incidents       | object    | Entity to incidents relationship.                                                                                                                                                                                                                                            |
| incidents       | data            | [object]  | Relationships.                                                                                                                                                                                                                                                               |
| data            | id              | string    | Associated data ID.                                                                                                                                                                                                                                                          |
| data            | type            | string    | Relationship type.                                                                                                                                                                                                                                                           |
| relationships   | oncall          | object    | Entity to oncalls relationship.                                                                                                                                                                                                                                              |
| oncall          | data            | [object]  | Relationships.                                                                                                                                                                                                                                                               |
| data            | id              | string    | Associated data ID.                                                                                                                                                                                                                                                          |
| data            | type            | string    | Relationship type.                                                                                                                                                                                                                                                           |
| relationships   | rawSchema       | object    | Entity to raw schema relationship.                                                                                                                                                                                                                                           |
| rawSchema       | data            | object    | Relationship entry.                                                                                                                                                                                                                                                          |
| data            | id              | string    | Associated data ID.                                                                                                                                                                                                                                                          |
| data            | type            | string    | Relationship type.                                                                                                                                                                                                                                                           |
| relationships   | relatedEntities | object    | Entity to related entities relationship.                                                                                                                                                                                                                                     |
| relatedEntities | data            | [object]  | Relationships.                                                                                                                                                                                                                                                               |
| data            | id              | string    | Associated data ID.                                                                                                                                                                                                                                                          |
| data            | type            | string    | Relationship type.                                                                                                                                                                                                                                                           |
| relationships   | schema          | object    | Entity to detail schema relationship.                                                                                                                                                                                                                                        |
| schema          | data            | object    | Relationship entry.                                                                                                                                                                                                                                                          |
| data            | id              | string    | Associated data ID.                                                                                                                                                                                                                                                          |
| data            | type            | string    | Relationship type.                                                                                                                                                                                                                                                           |
| included        | type            | string    | Entity.                                                                                                                                                                                                                                                                      |
|                 | links           | object    | List relation response links.                                                                                                                                                                                                                                                |
| links           | next            | string    | Next link.                                                                                                                                                                                                                                                                   |
| links           | previous        | string    | Previous link.                                                                                                                                                                                                                                                               |
| links           | self            | string    | Current link.                                                                                                                                                                                                                                                                |
|                 | meta            | object    | Relation response metadata.                                                                                                                                                                                                                                                  |
| meta            | count           | int64     | Total relations count.                                                                                                                                                                                                                                                       |
| meta            | includeCount    | int64     | Total included data count.                                                                                                                                                                                                                                                   |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": [
    {
      "attributes": {
        "from": {
          "kind": "string",
          "name": "string",
          "namespace": "string"
        },
        "to": {
          "kind": "string",
          "name": "string",
          "namespace": "string"
        },
        "type": "string"
      },
      "id": "string",
      "meta": {
        "createdAt": "2019-09-19T10:00:00.000Z",
        "definedBy": "string",
        "modifiedAt": "2019-09-19T10:00:00.000Z",
        "source": "string"
      },
      "relationships": {
        "fromEntity": {
          "data": {
            "id": "string",
            "type": "string"
          },
          "meta": {
            "createdAt": "string",
            "ingestionSource": "string",
            "modifiedAt": "string",
            "origin": "string"
          }
        },
        "toEntity": {
          "data": {
            "id": "string",
            "type": "string"
          },
          "meta": {
            "createdAt": "string",
            "ingestionSource": "string",
            "modifiedAt": "string",
            "origin": "string"
          }
        }
      },
      "subtype": "string",
      "type": "string"
    }
  ],
  "included": [
    {
      "attributes": {
        "apiVersion": "string",
        "description": "string",
        "displayName": "string",
        "kind": "string",
        "name": "string",
        "namespace": "string",
        "owner": "string",
        "tags": []
      },
      "id": "string",
      "meta": {
        "createdAt": "string",
        "ingestionSource": "string",
        "modifiedAt": "string",
        "origin": "string"
      },
      "relationships": {
        "incidents": {
          "data": [
            {
              "id": "string",
              "type": "string"
            }
          ]
        },
        "oncall": {
          "data": [
            {
              "id": "string",
              "type": "string"
            }
          ]
        },
        "rawSchema": {
          "data": {
            "id": "string",
            "type": "string"
          }
        },
        "relatedEntities": {
          "data": [
            {
              "id": "string",
              "type": "string"
            }
          ]
        },
        "schema": {
          "data": {
            "id": "string",
            "type": "string"
          }
        }
      },
      "type": "string"
    }
  ],
  "links": {
    "next": "/api/v2/catalog/relation?filter[from_ref]=service:service-catalog\u0026include=entity\u0026page[limit]=2\u0026page[offset]=2",
    "previous": "string",
    "self": "/api/v2/catalog/relation?filter[from_ref]=service:service-catalog\u0026include=entity\u0026page[limit]=2\u0026page[offset]=0"
  },
  "meta": {
    "count": "integer",
    "includeCount": "integer"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \# Curl command curl -X GET "https://api.datadoghq.com/api/v2/catalog/relation" \
-H "Accept: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" 
                
##### 

```python
"""
Get a list of entity relations returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.software_catalog_api import SoftwareCatalogApi

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = SoftwareCatalogApi(api_client)
    response = api_instance.list_catalog_relation()

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Get a list of entity relations returns "OK" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::SoftwareCatalogAPI.new
p api_instance.list_catalog_relation()
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Get a list of entity relations returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewSoftwareCatalogApi(apiClient)
	resp, r, err := api.ListCatalogRelation(ctx, *datadogV2.NewListCatalogRelationOptionalParameters())

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `SoftwareCatalogApi.ListCatalogRelation`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `SoftwareCatalogApi.ListCatalogRelation`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Get a list of entity relations returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.SoftwareCatalogApi;
import com.datadog.api.client.v2.model.ListRelationCatalogResponse;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    SoftwareCatalogApi apiInstance = new SoftwareCatalogApi(defaultClient);

    try {
      ListRelationCatalogResponse result = apiInstance.listCatalogRelation();
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling SoftwareCatalogApi#listCatalogRelation");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Get a list of entity relations returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_software_catalog::ListCatalogRelationOptionalParams;
use datadog_api_client::datadogV2::api_software_catalog::SoftwareCatalogAPI;

#[tokio::main]
async fn main() {
    let configuration = datadog::Configuration::new();
    let api = SoftwareCatalogAPI::with_config(configuration);
    let resp = api
        .list_catalog_relation(ListCatalogRelationOptionalParams::default())
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Get a list of entity relations returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.SoftwareCatalogApi(configuration);

apiInstance
  .listCatalogRelation()
  .then((data: v2.ListRelationCatalogResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
